/*
Licensed to the Apache Software Foundation (ASF) under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  The ASF licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing,
software distributed under the License is distributed on an
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, either express or implied.  See the License for the
specific language governing permissions and limitations
under the License.
*/

#ifndef CONFIG_CURVE_FP512BN_H
#define CONFIG_CURVE_FP512BN_H

#include"amcl.h"
#include"config_field_FP512BN.h"

// ECP stuff

#define CURVETYPE_FP512BN WEIERSTRASS
#define PAIRING_FRIENDLY_FP512BN BN
#define CURVE_SECURITY_FP512BN 128


#if PAIRING_FRIENDLY_FP512BN != NOT
//#define USE_GLV_FP512BN	  /**< Note this method is patented (GLV), so maybe you want to comment this out */
//#define USE_GS_G2_FP512BN /**< Well we didn't patent it :) But may be covered by GLV patent :( */
#define USE_GS_GT_FP512BN /**< Not patented, so probably safe to always use this */

#define POSITIVEX 0
#define NEGATIVEX 1

#define SEXTIC_TWIST_FP512BN M_TYPE
#define SIGN_OF_X_FP512BN POSITIVEX

#define ATE_BITS_FP512BN 

#endif

#if CURVE_SECURITY_FP512BN == 128
#define AESKEY_FP512BN 16 /**< Symmetric Key size - 128 bits */
#define HASH_TYPE_FP512BN SHA256  /**< Hash type */
#endif

#if CURVE_SECURITY_FP512BN == 192
#define AESKEY_FP512BN 24 /**< Symmetric Key size - 192 bits */
#define HASH_TYPE_FP512BN SHA384  /**< Hash type */
#endif

#if CURVE_SECURITY_FP512BN == 256
#define AESKEY_FP512BN 32 /**< Symmetric Key size - 256 bits */
#define HASH_TYPE_FP512BN SHA512  /**< Hash type */
#endif



#endif
